from fastapi import Path
from fastapi.exceptions import HTTPException
from pydantic import UUID4

from ...db import db_clients
from ...models.v1.commons import Detail, Message
from ...models.v1.id_mapper import Mapping, MappingQuery, Mappings


def add_routes_slides(app, late_init, api_v1_integration):
    @app.post("/v1/slides", responses={200: {"model": Mapping}, 409: {"model": Detail}})
    async def _(mapping: Mapping, payload=api_v1_integration.global_depends()):
        async with late_init.pool.acquire() as conn:
            clients = await db_clients(conn=conn)
            new_mapping = await clients.slide.add(mapping=mapping)
            if new_mapping is None:
                raise HTTPException(409, "EMPAIA ID already exists")
            return new_mapping

    @app.get("/v1/slides/empaia/{empaia_id}", responses={200: {"model": Mapping}, 404: {"model": Detail}})
    async def _(
        empaia_id: UUID4 = Path(
            ...,
            description="EMPAIA ID generated by Medical Data Service",
            example="b10648a7-340d-43fc-a2d9-4d91cc86f33f",
        ),
        payload=api_v1_integration.global_depends(),
    ):
        async with late_init.pool.acquire() as conn:
            clients = await db_clients(conn=conn)
            mapping = await clients.slide.get_local(empaia_id=empaia_id)
            if mapping is None:
                raise HTTPException(404, "EMPAIA ID not found")
            return mapping

    @app.put("/v1/slides/empaia/query", responses={200: {"model": Mappings}, 404: {"model": Detail}})
    async def _(
        mapping_query: MappingQuery,
        payload=api_v1_integration.global_depends(),
    ):
        async with late_init.pool.acquire() as conn:
            clients = await db_clients(conn=conn)
            mappings = await clients.slide.get_locals(empaia_ids=mapping_query.empaia_ids)
            if mappings is None:
                raise HTTPException(404, "EMPAIA IDs not found")
            return mappings

    @app.delete("/v1/slides/empaia/{empaia_id}", responses={200: {"model": Message}, 404: {"model": Detail}})
    async def _(
        empaia_id: UUID4 = Path(
            ...,
            description="EMPAIA ID generated by Medical Data Service",
            example="b10648a7-340d-43fc-a2d9-4d91cc86f33f",
        ),
        payload=api_v1_integration.global_depends(),
    ):
        async with late_init.pool.acquire() as conn:
            clients = await db_clients(conn=conn)
            mapping = await clients.slide.get_local(empaia_id=empaia_id)
            if mapping is None:
                raise HTTPException(404, "EMPAIA ID not found")
            await clients.slide.delete(empaia_id=empaia_id)
            return Message(message=f"deleted slide {empaia_id}")

    @app.get("/v1/slides/local/{local_id}", responses={200: {"model": Mappings}, 404: {"model": Detail}})
    async def _(
        local_id: str = Path(
            ..., description="Local ID provided by AP-LIS", example="3a1e3715-8945-4c13-8fc6-9c1c549cf85d"
        ),
        payload=api_v1_integration.global_depends(),
    ):
        async with late_init.pool.acquire() as conn:
            clients = await db_clients(conn=conn)
            mappings = await clients.slide.get_empaia(local_id=local_id)
            if mappings is None:
                raise HTTPException(404, "Local ID not found")
            return mappings
